#include <stdlib.h>
#include <stdio.h>

#include <unistd.h>
#include <signal.h>
#include <wait.h>
#include <string.h>
#include <ctype.h> /* ispace */ 

enum{ ERRFORK=80, ERREXEC, ERRSIGNALED, ERRAUTRE};

#define MAXLENCOMMAND 1024
#define VOIR(i) printf("Variable " #i " :%d\n",i)

int no_mots(const char *s)
{
  int i=0;

  while(*s != 0)
    {
      for(;isspace(*s);s++);
      
      if(*s == 0)
	break;
      
      i++;
      for(;!(*s == 0 || isspace(*s));s++);
    }

  return i;
}

char ** diviser(const char * s)
{
  char * t = malloc(strlen(s) +1);
  int n = no_mots(s),i;
  char **args = malloc((n + 1) * sizeof(char *));
  
  strcpy(t,s);
  
  for(i=0;i<n;i++)
    {
      for(;isspace(*t);t++);
            
      args[i] = t;
      
      for(;!(*t == 0 || isspace(*t));t++);
      
      *t++=0;
    }
  
  args[n+1] = NULL;

  return args;
}

pid_t pid;

void interruption(int sig)
{
  kill(sig,pid);
}

int mon_system(const char * s)
{
  int status;
  void (*old)(int);

  switch(fork())
    {
    case -1:
      return -ERRFORK;
    
    case 0:
      {
	/* Inutile de desallouer args !!! */
	char ** args = diviser(s);

	if(args[0] ==  NULL)
	  exit(0);

	if(execvp(args[0],args) < 0) 
	  exit(-ERREXEC);
      }
      
    default:
      old = signal(SIGINT,interruption);
      wait(&status);
      signal(SIGINT,old);

      if(WIFEXITED(status))
	return WEXITSTATUS(status);
      if(WIFSIGNALED(status))
	return -ERRSIGNALED;
      return -ERRAUTRE;
    }
}

/* Globale en bss : intialis  0 */
char command[MAXLENCOMMAND + 1];

int main(void)
{
  int val_ret;
  

  while(1)
    {
      printf("> ");
      fgets(command,MAXLENCOMMAND + 1,stdin);
       
      /* Enlever la nouvelle ligne */
      if(command[strlen(command)-1] == '\n')
	command[strlen(command)-1] = '\0';
      
      val_ret = mon_system(command);
      if(val_ret >= 0 )
	printf("Commande << %s >> execut "
		 "avec valeur de retour %d.\n", command,val_ret);
      else 
	{
	  printf("Commande << %s >> non execut ", command);
	  switch(val_ret)
	    {
	    case -ERRFORK:
	      printf("(erreur fork).\n");
	      break;
	    case -ERRSIGNALED:
	      printf("(commande signal).\n");
	      break;
	    case -ERREXEC:
	      printf("(erreur exec).\n");
	      break;
	    default:
	      printf("(erreur inconnu).\n");
	    }
	}
    }
  exit(EXIT_SUCCESS);
}
